org.apache.bcel.generic

## Class FieldOrMethod

- java.lang.Object
- - org.apache.bcel.generic.Instruction
  - - org.apache.bcel.generic.CPInstruction
    - - org.apache.bcel.generic.FieldOrMethod

- All Implemented Interfaces:
    Cloneable, IndexedInstruction, LoadClass, TypedInstruction
  Direct Known Subclasses:
    FieldInstruction, InvokeInstruction

      public abstract class FieldOrMethod
      extends CPInstruction
      implements LoadClass

  Super class for InvokeInstruction and FieldInstruction, since they have some methods in common!
  Version:
    $Id: FieldOrMethod.java 1812166 2017-10-13 23:48:11Z ggregory $

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.generic.CPInstruction

      `index`

    - ### Fields inherited from class org.apache.bcel.generic.Instruction

      `length, opcode`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `FieldOrMethod(short opcode, int index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getClassName(ConstantPoolGen cpg)` Deprecated. If the instruction references an array class, this method will return "java.lang.Object". For code generated by Java 1.5, this answer is sometimes wrong (e.g., if the "clone()" method is called on an array). A better idea is to use the `getReferenceType(ConstantPoolGen)` method, which correctly distinguishes between class types and array types.
    `ObjectType` | `getClassType(ConstantPoolGen cpg)` Deprecated. If the instruction references an array class, the ObjectType returned will be invalid. Use getReferenceType() instead.
    `ObjectType` | `getLoadClassType(ConstantPoolGen cpg)` Get the ObjectType of the method return or field.
    `String` | `getName(ConstantPoolGen cpg)`
    `ReferenceType` | `getReferenceType(ConstantPoolGen cpg)` Return the reference type representing the class, interface, or array class referenced by the instruction.
    `String` | `getSignature(ConstantPoolGen cpg)`

    - ### Methods inherited from class org.apache.bcel.generic.CPInstruction

      `dump, getIndex, getType, initFromFile, setIndex, toString, toString`

    - ### Methods inherited from class org.apache.bcel.generic.Instruction

      `accept, consumeStack, copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.bcel.generic.LoadClass

      `getType`

- - ### Constructor Detail

    - #### FieldOrMethod

          protected FieldOrMethod(short opcode,
                                  int index)

      Parameters:
        `index` - to constant pool

  - ### Method Detail

    - #### getSignature

          public String getSignature(ConstantPoolGen cpg)

      Returns:
        signature of referenced method/field.

    - #### getName

          public String getName(ConstantPoolGen cpg)

      Returns:
        name of referenced method/field.

    - #### getClassName

          @Deprecated
          public String getClassName(ConstantPoolGen cpg)

      Deprecated. If the instruction references an array class, this method will return "java.lang.Object". For code generated by Java 1.5, this answer is sometimes wrong (e.g., if the "clone()" method is called on an array). A better idea is to use the `getReferenceType(ConstantPoolGen)` method, which correctly distinguishes between class types and array types.
      Returns:
        name of the referenced class/interface

    - #### getClassType

          @Deprecated
          public ObjectType getClassType(ConstantPoolGen cpg)

      Deprecated. If the instruction references an array class, the ObjectType returned will be invalid. Use getReferenceType() instead.
      Returns:
        type of the referenced class/interface

    - #### getReferenceType

          public ReferenceType getReferenceType(ConstantPoolGen cpg)

      Return the reference type representing the class, interface, or array class referenced by the instruction.
      Parameters:
        `cpg` - the ConstantPoolGen used to create the instruction
      Returns:
        an ObjectType (if the referenced class type is a class or interface), or an ArrayType (if the referenced class type is an array class)

    - #### getLoadClassType

          public ObjectType getLoadClassType(ConstantPoolGen cpg)

      Get the ObjectType of the method return or field.
      Specified by:
        `getLoadClassType` in interface `LoadClass`
      Returns:
        type of the referenced class/interface
      Throws:
        `ClassGenException` - when the field is (or method returns) an array,

Copyright © 2004–2017 The Apache Software Foundation. All rights reserved.